<?php


namespace Controller;

use Traits\TResponse;
use Zeedhi\Framework\DTO\Request;
use Service\Organization as OrganizationService;

class Organization
{
    use TResponse;
    private $organizationService;

    public function __construct(OrganizationService $organizationService)
    {
        $this->organizationService = $organizationService;
    }

    public function findOrganizacaoInfo(Request $request)
    {
        try {
            $result = $this->organizationService->findOrganizacaoInfo();
            $this->sendResponse($result, 200);
        } catch (\Exception $e) {
            $this->sendResponse($this->createResponseError($e), 500);
        }
    }

    public function findDefaultCalendar(Request $request)
    {
        try {
            $result = $this->organizationService->findDefaultCalendar();
            $this->sendResponse($result, 200);
        } catch (\Exception $e) {
            $this->sendResponse($this->createResponseError($e), 500);
        }
    }
    
    public function saveOrganizacaoInfo(Request $request)
    {
        try {
            $params = $request->getParameters()['DATA'];
            $name = $params['NAME'];
            $foundation = $params['FOUNDATION'];
            $managers = $params['MANAGERS'];
            $document = $params['DOCUMENT'];
            $timeSheetRequired = $params['TIME_SHEET_REQUIRED'];
            $description = $params['DESCRIPTION'];
            $calendarDefault = $params['BASE_CALENDAR'];
            $calendar = $params['CALENDAR'];
            $structure = $params['STRUCTURE'];

            $result = $this->organizationService->saveOrganizacaoInfo($name, $foundation, $document,
            $description,$managers,$calendar,$calendarDefault,$structure,$timeSheetRequired);
            $this->sendResponse($result, 200);
        } catch (\Exception $e) {
            $this->sendResponse($this->createResponseError($e), 500);
        }
    }
}
